

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

local vehicleConfig
local rumbler
local path = "mods/sirenmod/sounds/"
local isHornOn = 0
local isLightbarOn = 0
local horn
local siren
local rumbler1
local rumbler2
local rumblerSwitch = 0
local throughSiren = 0
local alreadyPlayed = 0
local init = 0


--=======================================================================JSON CONFIG===========================================================================
local function jsonInit(jsonFile)
	vehicleConfig = jsonFile
	if init == 1 then
		obj:setVolumePitch(rumbler1, 0, 1)
		obj:setVolumePitch(rumbler2, 0, 1)
		obj:setVolumePitch(horn, 0, 1)
		obj:setVolumePitch(siren, 0, 1)
	end

	horn =         sounds.createSFXSource(path..vehicleConfig.Horn, 		'AudioDefaultLoop3D', "horn"..vehicleConfig.Name, 	     v.data.refNodes[0].ref)
	siren =        sounds.createSFXSource(path..vehicleConfig.Siren,    	'AudioDefaultLoop3D', "siren"..vehicleConfig.Name,       v.data.refNodes[0].ref)
	rumbler1 =     sounds.createSFXSource(path..vehicleConfig.Rumbler1, 	'AudioDefaultLoop3D', "rumbler1"..vehicleConfig.Name,	 v.data.refNodes[0].ref)
	rumbler2 =     sounds.createSFXSource(path..vehicleConfig.Rumbler2,     'AudioDefaultLoop3D', "rumbler2"..vehicleConfig.Name, 	 v.data.refNodes[0].ref)
	init = 1
end
--=======================================================================JSON CONFIG===========================================================================






local function onUpdate(dt)
	if init == 1 then

	if drivingSounds.switchActual ~= drivingSounds.switch and init == 1 then
		obj:setVolumePitch(rumbler1, 0, 1)		-- Disable all rumbler to prevent rumbler and horn playing at the same time if user disable siren while pressing horn
		obj:setVolumePitch(rumbler2, 0, 1)
		obj:setVolumePitch(horn, 0, 1)
	end


--=============================================HORN AND RUMBLER===============================================
	if isHornOn == 1 then -- If the horn is activated
			isLightbarOn = 0 --Disable the siren
		if isLightbarOn == 0 and electrics.values.lightbar == 0	then -- If siren is completly disabled then

			obj:setVolumePitch(rumbler1, 0, 1)		-- Disable all rumbler to prevent rumbler and horn playing
			obj:setVolumePitch(rumbler2, 0, 1)
			obj:setVolumePitch(horn, vehicleConfig.HornVolume, vehicleConfig.HornPitch)	
			
		else
		
			obj:setVolumePitch(horn, 0, 1)    -- at the same time if user disable siren while pressing horn	
			if rumblerSwitch == 0 then -- Switch rumbler (RUMBLER 1)
				obj:setVolumePitch(rumbler1, vehicleConfig.Rumbler1Volume, 1)
			else -- Switch rumbler (RUMBLER 2)
				obj:setVolumePitch(rumbler2, vehicleConfig.Rumbler2Volume, 1)	
			end
			
		end
	end
--=============================================HORN AND RUMBLER===============================================
	
	
	
	
	if siren then -- If sound have been loaded
	
		if electrics.values.lightbar == 0 or isLightbarOn == 0 then -- If siren is disabled
			obj:setVolumePitch(siren, 0, 1)	
		elseif electrics.values.lightbar == 1 and isLightbarOn == 1 then -- If siren is enabled
			obj:setVolumePitch(siren, vehicleConfig.SirenVolume, 1)		
		end
		
	end

	
		if electrics.values.lightbar == 1 and throughSiren == 1 then -- If lightbar is enabled and user enabled siren through the mod
			isLightbarOn = 1
			if alreadyPlayed == 0 then -- Prevent the sound to be played more than 1 time
				siren =        sounds.createSFXSource(path..vehicleConfig.Siren, 'AudioDefaultLoop3D', "siren"..vehicleConfig.Name, v.data.refNodes[0].ref)
				alreadyPlayed = 1
			end
		end
		if electrics.values.lightbar == 0 then -- If user stop lightbar
			isLightbarOn = 0
			alreadyPlayed = 0
			throughSiren = 0
		end
	end
end







local function toggle_siren()

	electrics.toggle_lightbar_signal()
	throughSiren = 1 -- Mean that the user have enabled siren through the mod
	
end







local function hornOn()
	isHornOn = 1
	if vehicleConfig ~= nil then horn = sounds.createSFXSource(path..vehicleConfig.Horn, 'AudioDefaultLoop3D', "horn"..vehicleConfig.Name, v.data.refNodes[0].ref) end
end







local function hornOff()
	if throughSiren == 1 then isLightbarOn = 1 end -- If siren was enabled then enable it again
	isHornOn = 0
	if	rumblerSwitch == 1 then rumblerSwitch = 0 else rumblerSwitch = 1 end -- Switch rumbler
	if init == 1 then
		obj:setVolumePitch(horn, 0, 1)
		obj:setVolumePitch(rumbler1, 0, 1)
		obj:setVolumePitch(rumbler2, 0, 1)
	end
end


M.jsonInit = jsonInit
M.hornOn = hornOn
M.hornOff = hornOff
M.toggle_siren = toggle_siren
M.onUpdate = onUpdate
M.updateGFX = onUpdate

return M